SMIME and Resteasy
========================
This example shows how to use SMIME over HTTP to encrypt and/or sign message bodies.  The examples use keys and certificates
generated by the 'openssl' command-line utility that is available on most unix-based systems as well as installable
on Windows.  If you're doing pure Java, then its fine to use the Java keytool and KeyStore facilities to manage your keys/certificates.
The example also has python clients to show how different languages interacting.  This is why we chose to use openssl
to generate our keys/certificates.

The pem files private.pem and cert.pem were generated with this command:

$ openssl req -x509 -nodes -days 365 -newkey rsa:1024 -keyout private.pem -out cert.pem


There are two ways to run the example:

$ mvn install

This builds, runs the WAR, and then invokes all the Java tests.  This basically shows Java to Java communication
passing back and forth SMIME messages over HTTP


The second way is to run the WAR and interact with Python clients:

1. mvn jetty:run

This starts the web server in interaction mode


2. Run one of the python clients

$ python getEncrypted.py
$ python getSigned.py
$ python postEncrypted.py
$ python postSigned.py
$ python getEncryptedSigned.py



